#!/usr/bin/env bash
set -e

virtualenv=$1
W=$2
stride_divider=$3
bidirectional=$4
threshold=$5
postprocess=$6
jpeg_compress=$7
jpeg_quality=$8
noise=$9
sigma=${10}
gray=${11}
median=${12}
gamma=${13}
gammalevel=${14}

stride=$(($W/$stride_divider))
stride=$(($stride+$stride%2))

if [ -d $virtualenv ]; then
  source $virtualenv/bin/activate
fi

ARGS=""

ARGS="$ARGS -W $W -S $stride --threshold $threshold"

if [ "$green_median" = "True" ]; then
        ARGS="$ARGS --green-median"
fi

if [ "$bidirectional" = "True" ]; then
        ARGS="$ARGS --bidirectional"
fi

if [ "$postprocess" = "True" ]; then
        if [ "$jpeg_compress" = "True" ]; then
                ARGS="$ARGS --jpeg $jpeg_quality"
        fi
        if [ "$noise" = "True" ]; then
                ARGS="$ARGS --noise $sigma"
                if [ "$gray" = "True" ]; then
                        ARGS="$ARGS --gray"
                fi
        fi
        if [ "$median" = "True" ]; then
                ARGS="$ARGS --median"
        fi
        if [ "$gamma" = "True" ]; then
                ARGS="$ARGS --gamma $gammalevel"
        fi
fi


if [ ! -d $virtualenv ]; then
  echo "Virtualenv not found" > demo_failure.txt
  exit 0
fi


source $virtualenv/bin/activate
main.py input_0.png $ARGS
